---
- hosts: workers
  become: true

  handlers:
  - name: docker status
    service: name=docker state=started

  tasks:
  - name: Install packages that allow apt to be used over HTTPS (1/14)
    apt:
      name: "{{ packages }}"
      state: present
      update_cache: yes
    vars:
      packages:
      - apt-transport-https
      - ca-certificates
      - curl
      - gnupg-agent
      - software-properties-common

  - name: Add an apt signing key for Docker (2/14)
    apt_key:
      url: https://download.docker.com/linux/ubuntu/gpg
      state: present

  - name: Add apt repository for stable version (3/14)
    apt_repository:
      repo: deb [arch=amd64] https://download.docker.com/linux/ubuntu xenial stable
      state: present

  - name: Install docker and its dependecies (4/14)
    apt: 
      name: "{{ packages }}"
      state: present
      update_cache: yes
    vars:
      packages:
      - docker-ce 
      - docker-ce-cli 
      - containerd.io
    notify:
      - docker status

  - name: Add 'vagrant' user to docker group (5/14)
    user:
      name: vagrant
      group: docker
  
  - name: Disabling swap - Disable swap (6/14)
    command: swapoff -a
    when: ansible_swaptotal_mb > 0

  - name: Disabling swap - Remove swapfile from /etc/fstab (7/14)
    mount:
      name: "{{ item }}"
      fstype: swap  
      state: absent
    with_items:
      - swap
      - none

  - name: Add an apt signing key for Kubernetes (8/14)
    apt_key:
      url: https://packages.cloud.google.com/apt/doc/apt-key.gpg
      state: present

  - name: Adding apt repository for Kubernetes (9/14)
    apt_repository:
      repo: deb https://apt.kubernetes.io/ kubernetes-xenial main
      state: present
      filename: kubernetes.list

  - name: Installing Kubernetes binaries (10/14)
    apt: 
      name: "{{ packages }}"
      state: present
      update_cache: yes
    vars:
      packages:
        - kubelet 
        - kubeadm 
        - kubectl

  - name: Restart kubelet (12/14)
    service:
      name: kubelet
      daemon_reload: yes
      state: restarted

  - name: Copy the join command to server location (13/14)
    copy: 
      src: join-command 
      dest: /tmp/join-command.sh 
      mode: 0777

  - name: Join the node to cluster (14/14)
    command: sh /tmp/join-command.sh